# HG changeset patch
# User Andrew Thornton <art27@cantab.net>
# Date 1471638095 -3600
#      Fri Aug 19 21:21:35 2016 +0100
# Node ID 006fe5e79583c4e14c0884c102ecaf2a21b1a71b
# Parent  046ade63abc408b9051cc35afc7c26ef1ef2bd92
Implement Uitable

* doc/interpreter/genpropdoc.m: Add documentation stubs
* doc/interpreter/gui.txi: Wire in uitable documentation
* doc/interpreter/module.mk: Wire in uitable documentation
* doc/interpreter/plot.txi: Wire in uitable documentation
* libgui/graphics/__init_qt__.cc: Add default foregroundcolor for uitable
* libgui/graphics/Backend.cc: Wire in uitable
* libgui/graphics/Canvas.cc: Wire in uitable
* libgui/graphics/module.mk: Add uitable to the build system
* libgui/graphics/ObjectFactory.cc: Add uitable to the ObjectFactory
* libgui/graphics/Table.cc: The main QT object representing a uitable
* libgui/graphics/Table.h: The main QT object representing a uitable
* libgui/graphics/QtHandlesUtils.cc: Add computeFont for uitable
* libinterp/corefcn/gl-render.cc: Wire in uitable
* libinterp/corefcn/graphics.cc: Add default positions and background color. Wire in uitable, and add properties for uitable.
* libinterp/corefcn/graphics.in.h: Add uitable properties object
* libinterp/corefcn/module.mk: Wire in str2double.h
* libinterp/corefcn/pr-output.cc: Make rational_approx non-static - needed for columnformat in uitable
* libinterp/corefcn/pr-output.h: Expose rational_approx in pr-output.h
* libinterp/corefcn/str2double.cc: Expose str2double1 as str2double_internal - needed to interpret data edits
* libinterp/corefcn/str2double.h: Expose str2double_internal
* libinterp/genprops.awk: rename internal value data as _data to avoid collisions with data in uitable
* scripts/gui/module.mk: Wire in uitable.m
* scripts/gui/uitable.m: uitable script

diff -r 046ade63abc4 -r 006fe5e79583 NEWS
--- a/NEWS	Fri Aug 19 21:05:48 2016 +0200
+++ b/NEWS	Fri Aug 19 21:21:35 2016 +0100
@@ -147,6 +147,7 @@
       reducevolume
       smooth3
       uibuttongroup
+      uitable
 
  ** Deprecated functions.
 
diff -r 046ade63abc4 -r 006fe5e79583 doc/interpreter/genpropdoc.m
--- a/doc/interpreter/genpropdoc.m	Fri Aug 19 21:05:48 2016 +0200
+++ b/doc/interpreter/genpropdoc.m	Fri Aug 19 21:21:35 2016 +0100
@@ -32,7 +32,8 @@
   objnames = {"root", "figure", "axes", "line", ...
               "text", "image", "patch", "surface", "light", ...
               "uimenu", "uibuttongroup", "uicontextmenu", "uipanel", ...
-              "uicontrol", "uitoolbar", "uipushtool", "uitoggletool"};
+              "uicontrol", "uitable", "uitoolbar", "uipushtool", ...
+              "uitoggletool"};
 
   ## Base properties
   base = getstructure ("base");
@@ -1426,6 +1427,41 @@
 
     endswitch
 
+  ## uitable Properties
+  elseif (strcmp (objname, "uitable"))
+      switch (field)
+        ## Overridden shared properties
+
+        ## Specific properties
+        case "backgroundcolor"
+        case "celleditcallback"
+        case "cellselectioncallback"
+        case "columneditable"
+        case "columnformat"
+        case "columnname"
+        case "columnwidth"
+        case "createfcn"
+        case "data"
+        case "deletefcn"
+        case "enable"
+        case "extent"
+        case "fontangle"
+        case "fontname"
+        case "fontsize"
+        case "fontunits"
+        case "fontweight"
+        case "foregroundcolor"
+        case "keypressfcn"
+        case "keyreleasefcn"
+        case "position"
+        case "rearrangeablecolumns"
+        case "rowname"
+        case "rowstriping"
+        case "tooltipstring"
+        case "units"
+
+      endswitch
+
   ## uitoolbar properties
   elseif (strcmp (objname, "uitoolbar"))
     switch (field)
diff -r 046ade63abc4 -r 006fe5e79583 doc/interpreter/gui.txi
--- a/doc/interpreter/gui.txi	Fri Aug 19 21:05:48 2016 +0200
+++ b/doc/interpreter/gui.txi	Fri Aug 19 21:21:35 2016 +0100
@@ -113,6 +113,8 @@
 
 @DOCSTRING(uipanel)
 
+@DOCSTRING(uitable)
+
 @DOCSTRING(uipushtool)
 
 @DOCSTRING(uitoggletool)
diff -r 046ade63abc4 -r 006fe5e79583 doc/interpreter/module.mk
--- a/doc/interpreter/module.mk	Fri Aug 19 21:05:48 2016 +0200
+++ b/doc/interpreter/module.mk	Fri Aug 19 21:21:35 2016 +0100
@@ -15,6 +15,7 @@
   doc/interpreter/plot-uicontextmenuproperties.texi \
   doc/interpreter/plot-uipanelproperties.texi \
   doc/interpreter/plot-uicontrolproperties.texi \
+  doc/interpreter/plot-uitableproperties.texi \
   doc/interpreter/plot-uitoolbarproperties.texi \
   doc/interpreter/plot-uipushtoolproperties.texi \
   doc/interpreter/plot-uitoggletoolproperties.texi
@@ -69,6 +70,9 @@
 doc/interpreter/plot-uicontrolproperties.texi: doc/interpreter/genpropdoc.m
 	$(AM_V_GEN)$(call gen-propdoc-texi,uicontrol)
 
+doc/interpreter/plot-uitableproperties.texi: doc/interpreter/genpropdoc.m
+	$(AM_V_GEN)$(call gen-propdoc-texi,uitable)
+
 doc/interpreter/plot-uitoolbarproperties.texi: doc/interpreter/genpropdoc.m
 	$(AM_V_GEN)$(call gen-propdoc-texi,uitoolbar)
 
diff -r 046ade63abc4 -r 006fe5e79583 doc/interpreter/plot.txi
--- a/doc/interpreter/plot.txi	Fri Aug 19 21:05:48 2016 +0200
+++ b/doc/interpreter/plot.txi	Fri Aug 19 21:21:35 2016 +0100
@@ -1406,6 +1406,7 @@
 * Uicontextmenu Properties::
 * Uipanel Properties::
 * Uicontrol Properties::
+* Uitable Properties::
 * Uitoolbar Properties::
 * Uipushtool Properties::
 * Uitoggletool Properties::
@@ -1544,6 +1545,14 @@
 
 @include plot-uicontrolproperties.texi
 
+@node Uitable Properties
+@subsubsection Uitable Properties
+@cindex uitable properties
+
+The @code{uitable} properties are:
+
+@include plot-uitableproperties.texi
+
 @node Uitoolbar Properties
 @subsubsection Uitoolbar Properties
 @cindex uitoolbar properties
diff -r 046ade63abc4 -r 006fe5e79583 libgui/graphics/Backend.cc
--- a/libgui/graphics/Backend.cc	Fri Aug 19 21:05:48 2016 +0200
+++ b/libgui/graphics/Backend.cc	Fri Aug 19 21:21:35 2016 +0100
@@ -58,6 +58,7 @@
            || go.isa ("uibuttongroup")
            || go.isa ("uimenu")
            || go.isa ("uicontextmenu")
+           || go.isa ("uitable")
            || go.isa ("uitoolbar")
            || go.isa ("uipushtool")
            || go.isa ("uitoggletool"))
@@ -91,6 +92,7 @@
       || go.isa ("uibuttongroup")
       || go.isa ("uimenu")
       || go.isa ("uicontextmenu")
+      || go.isa ("uitable")
       || go.isa ("uitoolbar")
       || go.isa ("uipushtool")
       || go.isa ("uitoggletool"))
@@ -122,6 +124,7 @@
       || pId == uibuttongroup::properties::ID___OBJECT__
       || pId == uimenu::properties::ID___OBJECT__
       || pId == uicontextmenu::properties::ID___OBJECT__
+      || pId == uitable::properties::ID___OBJECT__
       || pId == uitoolbar::properties::ID___OBJECT__
       || pId == uipushtool::properties::ID___OBJECT__
       || pId == uitoggletool::properties::ID___OBJECT__
diff -r 046ade63abc4 -r 006fe5e79583 libgui/graphics/Canvas.cc
--- a/libgui/graphics/Canvas.cc	Fri Aug 19 21:05:48 2016 +0200
+++ b/libgui/graphics/Canvas.cc	Fri Aug 19 21:21:35 2016 +0100
@@ -387,7 +387,7 @@
       if (childObj.isa ("axes"))
         axesList.append (childObj);
       else if (childObj.isa ("uicontrol") || childObj.isa ("uipanel")
-               || childObj.isa ("uibuttongroup"))
+               || childObj.isa ("uibuttongroup") || childObj.isa ("uitable"))
         {
           Matrix bb = childObj.get_properties ().get_boundingbox (false);
           QRectF r (bb(0), bb(1), bb(2), bb(3));
diff -r 046ade63abc4 -r 006fe5e79583 libgui/graphics/ObjectFactory.cc
--- a/libgui/graphics/ObjectFactory.cc	Fri Aug 19 21:05:48 2016 +0200
+++ b/libgui/graphics/ObjectFactory.cc	Fri Aug 19 21:21:35 2016 +0100
@@ -46,6 +46,7 @@
 #include "PushTool.h"
 #include "RadioButtonControl.h"
 #include "SliderControl.h"
+#include "Table.h"
 #include "TextControl.h"
 #include "ToggleButtonControl.h"
 #include "ToggleTool.h"
@@ -128,6 +129,8 @@
                 obj = Menu::create (go);
               else if (go.isa ("uicontextmenu"))
                 obj = ContextMenu::create (go);
+              else if (go.isa ("uitable"))
+                obj = Table::create (go);
               else if (go.isa ("uitoolbar"))
                 obj = ToolBar::create (go);
               else if (go.isa ("uipushtool"))
diff -r 046ade63abc4 -r 006fe5e79583 libgui/graphics/QtHandlesUtils.cc
--- a/libgui/graphics/QtHandlesUtils.cc	Fri Aug 19 21:05:48 2016 +0200
+++ b/libgui/graphics/QtHandlesUtils.cc	Fri Aug 19 21:21:35 2016 +0100
@@ -139,6 +139,9 @@
 
 template QFont computeFont<uibuttongroup> (const uibuttongroup::properties& props,
                                            int height);
+
+template QFont computeFont<uitable> (const uitable::properties& props,
+                                     int height);
 QColor
 fromRgb (const Matrix& rgb)
 {
